## laidout 0.096.1

=== Makefile ===
###############################################
##############                  ###############
#############  Laidout Makefile  ##############
##############                  ###############
###############################################

 # Makefile-toinclude, generated by configure, 
 # defines LAXDIR, PREFIX, and LAIDOUTVERSION
include Makefile-toinclude


 # where the main executable goes
BINDIR=$(PREFIX)/bin
 # like /usr/local/share/, examples go here: $SHAREDIR/laidout
SHAREDIR=$(PREFIX)/share


 ### If you want to be sure that an install does not clobber anything that exists
 ### already, then uncomment the line with the '--backup=t' and comment out the other.
#INSTALL=install -D --backup=t 
INSTALL=install -D

INSTALLDIR=install -d


LAIDOUTNAME=laidout-$(LAIDOUTVERSION)

laidout: touchdepends
	cd src && $(MAKE)
	cd src/po && $(MAKE)

all: laidout docs

icons:
	cd src/icons && make

docs:
	cd docs && doxygen
	
alldocs:
	cd docs && doxygen Doxyfile-with-laxkit

quickref:
	src/laidout -H > QUICKREF.html

install: 
	echo 'Installing to $(BINDIR)/laidout which points to $(BINDIR)/$(LAIDOUTNAME)'
	$(INSTALL) -m755 src/laidout $(BINDIR)/$(LAIDOUTNAME)
	$(INSTALLDIR) $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/examples
	$(INSTALL) -m644 -t $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/examples examples/*
	$(INSTALLDIR) $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/icons
	$(INSTALL) -m644 -t $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/icons src/icons/*.png
	$(INSTALLDIR) $(SHAREDIR)/applications
	$(INSTALL) -m644 deb/laidout.desktop $(SHAREDIR)/applications
	$(INSTALLDIR) $(SHAREDIR)/icons/hicolor/48x48/apps
	$(INSTALL) -m644 src/icons/laidout-48x48.png $(SHAREDIR)/icons/hicolor/48x48/apps/laidout.png
	$(INSTALLDIR) $(SHAREDIR)/icons/hicolor/scalable/apps
	$(INSTALL) -m644 src/icons/laidout.svg $(SHAREDIR)/icons/hicolor/scalable/apps/laidout.svg
	$(INSTALLDIR)       $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/coop/processing
	$(INSTALL) -m644 -t $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/coop/processing coop/processing/*
	$(INSTALLDIR)       $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/coop/scribus
	$(INSTALL) -m644 -t $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/coop/scribus coop/scribus/*
	$(INSTALLDIR)       $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/plugins
	$(INSTALL) -m755 -t $(SHAREDIR)/laidout/$(LAIDOUTVERSION)/plugins src/plugins/*.so

	rm -f $(BINDIR)/laidout
	ln -s $(LAIDOUTNAME) $(BINDIR)/laidout
	cd src/po && $(MAKE) install

# ****** TODO!!! this is very primitive make uninstall!!
# should only uninstall things that were actually installed. Any resource added by
# the user to the system wide directories should not be uninstalled. Should use
# config log perhaps. The $(BINDIR)/laidout should be removed only if it points to
# $(BINDIR)/$(LAIDOUTNAME)
uninstall: 
	echo 'Uninstalling laidout.'
	echo '  Removing $(BINDIR)/laidout'
	rm -f  $(BINDIR)/laidout
	echo '  Removing $(SHAREDIR)/laidout/$(LAIDOUTVERSION)'
	rm -fr $(SHAREDIR)/laidout/$(LAIDOUTVERSION)
	echo '  Removing $(BINDIR)/$(LAIDOUTNAME)'
	rm -f  $(BINDIR)/$(LAIDOUTNAME)
	cd src/po && $(MAKE) uninstall

#link debian to deb if not there.. Debian guidelines say don't put 
#a "debian" directory in upstream sources by default.
deb: touchdepends
	if [ ! -e debian ] ; then ln -s deb debian; fi
	dpkg-buildpackage -rfakeroot

hidegarbage: touchdepends
	cd src && $(MAKE) hidegarbage

unhidegarbage: touchdepends
	cd src && $(MAKE) unhidegarbage

depends: touchdepends
	cd src && $(MAKE) depends

touchdepends:
	touch src/makedepend
	touch src/calculator/makedepend
	touch src/dataobjects/makedepend
	touch src/filetypes/makedepend
	touch src/impositions/makedepend
	touch src/interfaces/makedepend
	touch src/printing/makedepend
	touch src/api/makedepend
	touch src/polyptych/src/makedepend
	touch src/plugins/makedepend

dist-clean: clean
	rm -f Makefile-toinclude config.log src/version.h src/configured.h
	rm -f src/makedepend               src/makedepend.bak
	rm -f src/calculator/makedepend    src/calculator/makedepend.bak
	rm -f src/dataobjects/makedepend   src/dataobjects/makedepend.bak
	rm -f src/filetypes/makedepend     src/filetypes/makedepend.bak
	rm -f src/impositions/makedepend   src/impositions/makedepend.bak
	rm -f src/interfaces/makedepend    src/interfaces/makedepend.bak
	rm -f src/printing/makedepend      src/printing/makedepend.bak
	rm -f src/api/makedepend           src/api/makedepend.bak
	rm -f src/polyptych/src/makedepend src/polyptych/src/makedepend.bak
	rm -f src/po/*.mo

.PHONY: all icons laidout dist-clean clean docs install uninstall hidegarbage unhidegarbage depends touchdepends deb
clean:
	cd src && $(MAKE) clean
	cd src/polyptych && $(MAKE) clean

=== laxkit/Makefile ===
################################################
##############                   ###############
#############   Laxkit Makefile   ##############
##############                   ###############
################################################
#
# When installing include headers, make sure to install into
# something like: lax-version/lax/*.h. This makes it easy for users to
# do g++ -I/usr/local/include/lax-version for including lax/whatever.
# Allows multiple versions of the kit to be installed without serious
# conflicts.
#
#
# to make shared library,
# objects must be compiled without -g and:
# 	g++ -fPIC -c blah.cc -o blah.o
# and linked thus:
# 	g++ -shared -fPIC -o blah.so blah.o ...


 # Where to install stuff, currently:
 #   prefix/include
 #   prefix/lib
#PREFIX=/usr/local
#PREFIX=testinstall
include Makefile-toinclude

## Comment out the next line to disable anything to do with Imlib2.
EXTRAS= -DLAX_USES_IMLIB

## Comment out the next line to not compile in debugging info
DEBUGFLAGS= -g




 # the libs get installed here
LIBDIR=$(PREFIX)/lib
BINDIR=$(PREFIX)/bin

 # header files get installed in this directory like this: includedir/lax-version/lax/*.h
INCLUDEDIR=$(PREFIX)/include

 # documentation goes here, like: /usr/share/doc/laxkit/lax-0.0.4
DOCDIR=$(PREFIX)/share/doc/laxkit/laxkit-$(LAXKITVERSION)


### If you want to be sure that an install does not clobber anything that exists
### already, then uncomment the line with the '--backup=t' and comment out the other.
#INSTALL=install --backup=t 
INSTALL=install





LAXDIR= lax
LAXOBJDIR=objs



#this compiles the core laxkit only, not laxinput
almostall: touchdepends lax interfaces
	@echo "  -----------Done!-------------" 


all: touchdepends lax interfaces laxinput
	@echo "  -----------Done!-------------" 


install-docs:
	echo "---- installing docs `date` -----" >> install.log
	$(INSTALL) -d $(DOCDIR)
	$(INSTALL) -d $(DOCDIR)/html
	$(INSTALL) -D -m644 docs/style.css $(DOCDIR)
	$(INSTALL) -D -m644 docs/*.html $(DOCDIR)
	$(INSTALL) -D -m644 docs/*.png $(DOCDIR)
	$(INSTALL) -D -m644 docs/*.jpg $(DOCDIR)
	$(INSTALL) -D -m644 docs/html/* $(DOCDIR)/html
	ls $(DOCDIR)/*  >> install.log
	ls $(DOCDIR)/html/* >> install.log

icons:
	cd lax/icons && make

install: lax interfaces laxinput
	echo "---- installing `date` -----" >> install.log
	$(INSTALL) -D -m644 $(LAXDIR)/liblaxkit.a $(LIBDIR)/liblaxkit.a && \
		echo '$(LIBDIR)/liblaxkit.a' >> install.log
	$(INSTALL) -D -m644 $(LAXDIR)/liblaxkit.so.$(LAXKITVERSION) $(LIBDIR)/liblaxkit.so.$(LAXKITVERSION) && \
		echo '$(LIBDIR)/liblaxkit.so.$(LAXKITVERSION)' >> install.log
	$(INSTALL) -D -m644 $(LAXDIR)/interfaces/liblaxinterfaces.a $(LIBDIR)/liblaxinterfaces.a && \
		echo '$(LIBDIR)/liblaxinterfaces.a' >> install.log
	$(INSTALL) -D -m644 $(LAXDIR)/interfaces/liblaxinterfaces.so.$(LAXKITVERSION) $(LIBDIR)/liblaxinterfaces.so.$(LAXKITVERSION) && \
		echo '$(LIBDIR)/liblaxinterfaces.so.$(LAXKITVERSION)' >> install.log
	$(INSTALL) -d $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax/interfaces
	$(INSTALL) -D -m644 $(LAXDIR)/lists.cc $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax/lists.cc && \
		echo '$(LIBDIR)/lists.cc' >> install.log
	$(INSTALL) -D -m644 $(LAXDIR)/refptrstack.cc $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax/refptrstack.cc && \
		echo '$(LIBDIR)/refptrstack.cc' >> install.log
	$(INSTALL) -D -m644 $(LAXDIR)/*.h $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax
	$(INSTALL) -D -m644 $(LAXDIR)/interfaces/*.h $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax/interfaces
	ls $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax/*.h $(INCLUDEDIR)/lax-$(LAXKITVERSION)/lax/interfaces/*.h >> install.log
	$(INSTALL) -D -m711 laxinput/laxinput $(BINDIR)/laxinput && \
		echo '$(BINDIR)/laxinput' >> install.log


uninstall: 
	rm -vf $(LIBDIR)/liblaxkit.a
	rm -vf $(LIBDIR)/liblaxinterfaces.a
	rm -v -rf $(INCLUDEDIR)/lax-$(LAXKITVERSION)

#this mkdir stuff is kind of an ugly hack so that when I do 'svn status' the html dir, which
#has a million files will not show up
docs:
	cd docs && doxygen

lax:
	cd lax && $(MAKE) all

interfaces:
	cd lax/interfaces && $(MAKE) all

laxinput: lax interfaces
	cd laxinput/ && $(MAKE)

touchdepends:
	touch lax/makedepend
	touch lax/interfaces/makedepend

depends:
	touch lax/makedepend
	touch lax/interfaces/makedepend
	cd lax && $(MAKE) depends
	cd lax/interfaces && $(MAKE) depends

deb:
	if [ ! -e debian ] ; then ln -s debian-lo debian; fi
	dpkg-buildpackage -rfakeroot


#---------- garbage be-gone -----------------
# This basically changes in *.cc all occurrences of 
# '(whitespace)DBG' to '(same ws)//DBG'.
hidegarbage:
	cd lax && $(MAKE) hidegarbage

# This changes in *.cc all occurrences of 
# '(whitespace)//DBG' to '(same ws)DBG'.
unhidegarbage:
	cd lax && $(MAKE) unhidegarbage


#---------- clean up and go home -----------------

# Like clean, but also remove logs of any previous install
dist-clean: clean 
	rm -f install.log
	rm -rf docs/html
	rm -rf Makefile-toinclude config.log lax/configured.h lax/version.h

.PHONY: clean docs lax interfaces depends unhidegarbage hidegarbage laxinput icons deb
clean:
	cd lax && rm -f *.o *.a *.so *.so.*
	cd lax/interfaces && rm -f *.o *.a *.so *.so.*

=== src/Makefile ===
###################################################
##############                      ###############
#############  Laidout Src Makefile  ##############
##############                      ###############
###################################################

include ../Makefile-toinclude
LAXIDIR=$(LAXDIR)/interfaces


LD=g++
LDFLAGS= $(EXTRA_LDFLAGS) -L/usr/local/lib -L/usr/X11R6/lib -rdynamic -lXi -lXext -lX11 -lm -lpng `imlib2-config --libs` `freetype-config --libs`\
		 `cups-config --libs` -ldl -lXft
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= $(HIDEGARBAGE) -Wall $(DEBUGFLAGS) $(EXTRA_CPPFLAGS)  -I$(LAXDIR)/.. `freetype-config --cflags` -I$(POLYPTYCHBASEDIR)


#---optional libs:
ifeq ($(LAIDOUT_USES_SQLITE), yes)
OPTIONALLIBS= -lsqlite3
endif


#---polyptych related:
ifeq ($(LAIDOUT_USING_GL), yes)
#---if gl:
POLYPTYCHLIBS= -lGraphicsMagick++ -ltiff -lGL -lGLU -lftgl 
POLYPTYCH_GL_OBJS=polyptych/src/hedronwindow.o  polyptych/src/glbase.o  polyptych/src/gloverlay.o  polyptych/src/polyrender.o
POLYPTYCHFORLAIDOUT=polyptychgl

else
#---if no gl:
POLYPTYCHLIBS= 
POLYPTYCH_GL_OBJS= 
POLYPTYCHFORLAIDOUT=polyptych
endif

#---either
POLYPTYCHOBJS=polyptych/src/nets.o polyptych/src/poly.o


dirs= \
	api \
	calculator \
	dataobjects \
	filetypes \
	impositions \
	interfaces \
	plugins \
	printing

objs= \
	utils.o \
	fieldplace.o \
	stylemanager.o \
	papersizes.o \
	plaintext.o \
	page.o \
	spreadview.o \
	document.o \
	project.o \
	guides.o \
	interfaces.o \
	autosavewindow.o \
	about.o \
	buttonbox.o \
	commandwindow.o \
	plaintextwindow.o \
	headwindow.o \
	helpwindow.o \
	settingswindow.o \
	newdoc.o \
	viewwindow.o \
	palettes.o \
	drawdata.o \
	spreadeditor.o \
	laidout-more.o \
	importimage.o \
	importimagesdialog.o \
	laidoutprefs.o \
	laidout.o 

#object files from other directories. Listing them all explicitly to prevent
#spurious inclusion of temporary testing stuff.
otherobjs= \
	calculator/values.o \
	calculator/calculator.o \
	calculator/interpreter.o \
	calculator/curvevalue.o \
	calculator/shortcuttodef.o \
	impositions/imposition.o \
	impositions/impositioneditor.o \
	impositions/singles.o \
	impositions/impositions.o \
	impositions/dodecahedron.o \
	impositions/box.o \
	impositions/netimposition.o \
	impositions/simplenet.o \
	impositions/signatures.o \
	impositions/signatureinterface.o \
	impositions/netdialog.o \
	impositions/polyptychwindow.o \
	impositions/singleseditor.o \
	plugins/plugin.o \
	api/reimpose.o \
	api/openandnew.o \
	api/importexport.o \
	api/functions.o \
	interfaces/actionarea.o \
	interfaces/nupinterface.o \
	interfaces/aligninterface.o \
	interfaces/anchorinterface.o \
	interfaces/pagerangeinterface.o \
	interfaces/graphicalshell.o \
	interfaces/objectindicator.o \
	interfaces/paperinterface.o \
	interfaces/cloneinterface.o \
	interfaces/animationinterface.o \
	interfaces/objecttree.o \
	interfaces/pagemarkerinterface.o \
	interfaces/nodeinterface.o \
	interfaces/nodeeditor.o \
	interfaces/nodes.o \
	interfaces/objectfilterinterface.o \
	printing/print.o \
	printing/psfilters.o \
	printing/pscolorpatch.o \
	printing/psgradient.o \
	printing/psimage.o \
	printing/psimagepatch.o \
	printing/pspathsdata.o \
	printing/pseps.o \
	printing/epsutils.o \
	printing/psout.o \
	filetypes/filefilters.o \
	filetypes/filters.o \
	filetypes/exportdialog.o \
	filetypes/importdialog.o \
	filetypes/image.o \
	filetypes/image-gs.o \
	filetypes/laidoutimport.o \
	filetypes/pdf.o \
	filetypes/podofoimposeplan.o \
	filetypes/postscript.o \
	filetypes/ppt.o \
	filetypes/scribus.o \
	filetypes/svg.o \
	dataobjects/group.o \
	dataobjects/objectcontainer.o \
	dataobjects/objectfilter.o \
	dataobjects/drawableobject.o \
	dataobjects/datafactory.o \
	dataobjects/groupinterface.o \
	dataobjects/epsdata.o \
	dataobjects/limagepatch.o \
	dataobjects/limagedata.o \
	dataobjects/limageinterface.o \
	dataobjects/lgradientdata.o \
	dataobjects/lperspectiveinterface.o \
	dataobjects/lpathsdata.o \
	dataobjects/mysterydata.o \
	dataobjects/lsomedataref.o \
	dataobjects/lengraverfilldata.o \
	dataobjects/lcaptiondata.o \
	dataobjects/ltextonpath.o \
	dataobjects/lvoronoidata.o \
	dataobjects/printermarks.o \


all: laidout

laidout: lax laxinterface $(dirs) $(objs) $(POLYPTYCHFORLAIDOUT)
	$(LD) $(otherobjs) $(objs) $(POLYPTYCH_GL_OBJS) $(POLYPTYCHOBJS) -L$(LAXIDIR) -L$(LAXDIR) -llaxinterfaces -llaxkit -lharfbuzz -lcairo -lfontconfig $(LDFLAGS) $(OPTIONALLIBS) -lreadline -lcrypto $(POLYPTYCHLIBS) -o $@

icons:
	cd src/icons && $(MAKE)
	cd $(LAXDIR)/icons && $(MAKE)
									 
polyptych:
	cd $(POLYPTYCHBASEDIR)/polyptych/src && $(MAKE) forlaidout

polyptychgl:
	cd $(POLYPTYCHBASEDIR)/polyptych/src && $(MAKE) forlaidoutgl

api:
	cd api && $(MAKE)

calculator:
	cd calculator && $(MAKE)

dataobjects:
	cd dataobjects && $(MAKE)

impositions:
	cd impositions && $(MAKE)

interfaces:
	cd interfaces && $(MAKE)

filetypes:
	cd filetypes && $(MAKE)

printing:
	cd printing && $(MAKE)

plugins:
	cd $@ && $(MAKE)

addons:
	cd plugins && $(MAKE) plugins

# This changes in *.cc all occurrences of '(whitespace)DBG' to '(same ws)//DBG' and
# '(whitespace)//DBG' to '(same ws)////DBG'
# which is useful when assembling for a release, because it disables all the spewing
# of info to the terminal.. I couldn't figure out how to do it with a simple compile flag
# like #defining DBG to be: //
hidegarbage:
	./hidegarbage *.cc
	for NAME in $(dirs); do $(MAKE) -C $$NAME hidegarbage; done

# This changes in *.cc all occurrences of 
# '(whitespace)//DBG' to '(same ws)DBG'.
unhidegarbage:
	./hidegarbage -0 *.cc
	for NAME in $(dirs); do $(MAKE) -C $$NAME unhidegarbage; done

lax:
	cd $(LAXDIR) && $(MAKE)

laxinterface:
	cd $(LAXIDIR) && $(MAKE)

test2: lax laxinterface interfaces test2.o papersizes.o
	$(LD) test2.o styles.o dataobjects/group.o dataobjects/objectcontainer.o papersizes.o interfaces/paperinterface.o $(LDFLAGS)  -llaxinterfaces -llaxkit -o $@

test: lax laxinterface stylewindow.o  styles.o stylemanager.o test.o
	$(LD) test.o stylewindow.o styles.o stylemanager.o $(LDFLAGS) -llaxinterfaces -llaxkit -o $@

docs:
	cd ../docs && doxygen 

alldocs:
	cd ../docs && doxygen Doxyfile-with-laxkit

depends:
	makedepend -fmakedepend -I$(LAXDIR)/.. -Y *.cc
	for NAME in $(dirs); do $(MAKE) -C $$NAME depends; done
	cd $(POLYPTYCHBASEDIR)/polyptych/src && $(MAKE) depends

include makedepend


.PHONY: clean lax docs $(dirs) addons hidegarbage unhidegarbage polyptych polyptychgl
clean:
	rm -f laidout *.o
	for NAME in $(dirs); do $(MAKE) -C $$NAME clean; done

=== laxkit/examples/Makefile ===
##############################################
##############                 ###############
#############  Laxkit/examples  ##############
##############                 ###############
##############################################

include ../Makefile-toinclude

LAXDIR= ../lax
LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)


OPTIONALLIBS=

ifeq ($(LAX_USES_SQLITE), yes)
OPTIONALLIBS= -lsqlite3
endif



LD=g++
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm -lcairo `freetype-config --libs` `imlib2-config --libs` $(OPTIONALLIBS) -lfontconfig -lXext -lXi -lXft -lcrypto -lharfbuzz -L$(LAXDIR) -L$(LAXIDIR)
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= $(DEBUGFLAGS) -I$(LAXDIR)/.. -std=c++11 `freetype-config --cflags`



examples= \
	laxhello \
	interfs \
	themeeditor \
	timers


all: laxhello interfs timers


interfs: lax laxinterface interfs.o
	$(LD) interfs.o -llaxinterfaces -llaxkit $(LDFLAGS) -o $@

interfs2: lax laxinterface interfs2.o
	$(LD) interfs2.o normalinterface.o joininterface.o -llaxinterfaces -llaxkit $(LDFLAGS) -o $@

vfill: lax laxinterface vfill.o
	$(LD) vfill.o  -llaxinterfaces -llaxkit $(LDFLAGS) -o $@

#vfill.o: vfill.cc /home/tom/other/p/github/laxkit/lax/interfaces/engravermapping.cc /home/tom/other/p/github/laxkit/lax/interfaces/RESEARCH/blur.cc

cairotest: lax laxinterface cairotest.o
	$(LD) $@.o  -llaxinterfaces -llaxkit -lharfbuzz $(LDFLAGS) -o $@

testevents: lax laxinterface testevents.o
	$(LD) $@.o  -llaxinterfaces -llaxkit $(LDFLAGS) -o $@

themeeditor: lax laxinterface themeeditor.o
	$(LD) $@.o  -llaxinterfaces -llaxkit $(LDFLAGS) -o $@

test: lax laxinterface test.o
	$(LD) $@.o  -llaxinterfaces -llaxkit $(LDFLAGS) -o $@


laxhello: lax laxinterface laxhello.cc laxhello.o
	$(LD) $@.o -llaxinterfaces -llaxkit $(LDFLAGS) -o $@

thingpreviewer: lax thingpreviewer.o
	$(LD) $@.o -llaxkit $(LDFLAGS) -o $@

timers: lax timers.o
	$(LD) $@.o -llaxkit $(LDFLAGS) -o $@

stationrotater: lax stationrotater.o
	$(LD) $@.o -llaxkit $(LDFLAGS) -o $@

depends:
	touch makedepend
	makedepend -fmakedepend -I$(LAXDIR)/.. -Y *.cc
	#cd interfaces && $(MAKE) depends

#-----------------------------------------------


lax:
	cd $(LAXDIR) && $(MAKE)

laxinterface:
	cd $(LAXDIR)/interfaces && $(MAKE)



#-----------------------------------------------

.PHONY: clean all
clean:
	rm -f *.o
	rm -f $(examples)

=== laxkit/lax/Makefile ===
################################################
###########                       ##############
##########   Laxkit/lax Makefile   #############
############                      ##############
################################################
#
# You should not have to edit anything in this file.
#
#
# 
#Note:
# to make shared library,
# objects must be compiled without -g and:
# 	g++ -fPIC -c blah.cc -o blah.o
# and linked thus:
# 	g++ -shared -fPIC -o blah.so blah.o ...


 # Where to install stuff, currently:
 #   prefix/include
 #   prefix/lib
#PREFIX=/usr/local

LAX_USING_XLIB=1


## Comment out the next line to not compile in debugging info
## Or use the second one to  not compile in debugging info and also hide all the 
##   output that would otherwise scroll by on the terminal screen.
DEBUGFLAGS= -g -gdwarf-2
#DEBUGFLAGS= -DHIDEGARBAGE



 # the libs get installed here
LIBDIR=$(PREFIX)/lib

 # header files get installed in this directory like this: includedir/lax-version/lax/*.h
INCLUDEDIR=$(PREFIX)/include

### If you want to be sure that an install does not clobber anything that exists
### already, then uncomment the line with the '--backup=t' and comment out the other.
#INSTALL=install --backup=t 
INSTALL=install



include ../Makefile-toinclude

#EXTRAS:= $(EXTRAS) 
#-DLAX_USES_IMLIB  -DLAX_USES_CAIRO
LAXDIR= .
LAXOBJDIR=objs

CC=g++
LD=g++
OPTIMIZATION=
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm  -lpng

## use the second one to make .so
## else the first for static libs only
## the -fPIC for static makes the static lib a little larger
#FPIC=
FPIC= -fPIC

CPPFLAGS= $(OPTIMIZATION) $(EXTRAS) $(DEBUGFLAGS) $(FPIC) -I$(LAXDIR)/.. -I/usr/X11R6/include -Wall `freetype-config --cflags`



objs= \
	refcounted.o \
	anobject.o \
	lark.o \
	dump.o \
	errorlog.o \
	strmanip.o \
	utf8utils.o \
	transformmath.o \
	vectors.o \
	doublebbox.o \
	fileutils.o \
	freedesktop.o \
	tagged.o \
	iobuffer.o \
	attributes.o \
	units.o \
	undo.o \
	fontmanager.o \
	fontmanager-xlib.o \
	fontmanager-cairo.o \
	fontscanner.o \
	laximages.o \
	laximages-imlib.o \
	laximages-cairo.o \
	laximlib.o \
	laxcairo.o \
	dateutils.o \
	screencolor.o \
	laxdevices.o \
	events.o \
	shortcuts.o \
	resources.o \
	objectfactory.o \
	themes.o \
	anxapp.o \
	anxapp-laxrc.o \
	laxoptions.o \
	previewable.o \
	gradientstrip.o \
	anxwindow.o \
	newwindowobject.o \
	tooltip.o \
	laxutils.o \
	bitmaputils.o \
	noise.o \
	iconmanager.o \
	misc.o \
	buttondowninfo.o \
	bezutils.o \
	displayer.o \
	displayer-xlib.o \
	displayer-cairo.o \
	messagebar.o \
	menuinfo.o \
	filemenuinfo.o \
	texteditbase-utf8.o \
	textxeditbase-utf8.o \
	funcframe.o \
	panuser.o \
	pancontroller.o \
	panpopup.o \
	scroller.o \
	boxarrange.o \
	winframebox.o \
	rowframe.o \
	boxselector.o \
	iconselector.o \
	tabframe.o \
	buttonbase.o \
	button.o \
	imageinfo.o \
	lineedit.o \
	multilineedit.o \
	promptedit.o \
	lineinput.o \
	itemslider.o \
	iconslider.o \
	numslider.o \
	checkbox.o \
	progressbar.o \
	scrolledwindow.o \
	menuselector.o \
	popupmenu.o \
	menubutton.o \
	sliderpopup.o \
	quickfileopen.o \
	colorspace.o \
	colors.o \
	colorbase.o \
	colorsliders.o \
	colorbox.o \
	palette.o \
	palettewindow.o \
	rulerwin.o \
	stackframe.o \
	messagebox.o \
	overwrite.o \
	inputdialog.o \
	filepreviewer.o \
	filedialog.o \
	imagedialog.o \
	simpleprint.o \
	printdialog.o \
	fontdialog.o \
	dateselector.o \
	splitwindow.o \
	treeselector.o \
	shortcutwindow.o \
	curveinfo.o \

#	tableframe.o \
#	colorselector.o \
#




#this compiles the core laxkit only, not interfaces
almostall: $(objs) liblaxkit.a
	@echo "  -----------Done!-------------" 

all: $(objs) liblaxkit.a interfaces liblaxkit.so.$(LAXKITVERSION)
	@echo "  -----------Done!-------------" 

# This changes in *.cc all occurrences of '(whitespace)DBG' to '(same ws)//DBG' and
# '(whitespace)//DBG' to '(same ws)////DBG'
# which is useful when assembling for a release, because it disables all the spewing
# of info to the terminal.. I couldn't figure out how to do it with a simple compile flag
# like #defining DBG to be: //
hidegarbage:
	./hidegarbage *.cc
	cd interfaces && $(MAKE) hidegarbage

# This changes in *.cc all occurrences of 
# '(whitespace)//DBG' to '(same ws)DBG'.
unhidegarbage:
	./hidegarbage -0 *.cc
	cd interfaces && $(MAKE) unhidegarbage



docs:
	cd ../docs && doxygen

interfaces:
	cd interfaces && $(MAKE) all


#----------------- Dynamic libs ---------------------------
#these .so makers require that all object files be compiled with -fPIC,
#which ultimately adds to the overall size of the static archive
liblaxkit.so.$(LAXKITVERSION): $(objs)
	$(LD) -shared -fPIC  $(objs) -o $@


#----------------- Static libs ---------------------------
liblaxkit.a: $(objs)
	ar cr $@ $(objs)


#----------------- Other ---------------------------
depends:
	touch makedepend
	makedepend -fmakedepend -I$(LAXDIR)/.. -Y *.cc
	cd interfaces && $(MAKE) depends

include makedepend


#------- Testing Stuff ----------------

#test.o: $(coreincludes) panuser.h pancontroller.h test.h test.cc


#---------- clean up and go home -----------------

# Like clean, but also remove logs of any previous install
dist-clean: clean
	rm -f install.log

.PHONY: clean docs interfaces hidegarbage unhidegarbage
clean:
	rm -f *.o *.a *.so
	cd interfaces && $(MAKE) clean

=== laxkit/laxinput/Makefile ===
########################################
##############           ###############
#############  Laxinput   ##############
##############           ###############
########################################


###Set LAXDIR to where the Laxkit headers are:
LAXDIR= ../lax





################ You shouldn't need to set anything below here ############################


###Include options from configure
include ../Makefile-toinclude


OPTIONALLIBS=

ifeq ($(LAX_USES_SQLITE), yes)
OPTIONALLIBS= -lsqlite3
endif



LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)

LD=g++
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm -lcairo `imlib2-config --libs` `freetype-config --libs` $(OPTIONALLIBS) -lfontconfig -lXext -lXi -lXft -lssl -L$(LAXDIR) -L$(LAXIDIR)
DEBUGFLAGS= -g -Wall
CPPFLAGS= $(DEBUGFLAGS) -I$(LAXDIR)/.. `freetype-config --cflags`



	


laxinput: lax laxinput.o
	$(LD) $@.o -llaxkit $(LDFLAGS) -o $@

#$(LD) $(LDFLAGS) $@.o -llaxkit -o $@

depends:
	touch makedepend
	makedepend -fmakedepend -I$(LAXDIR)/.. -Y *.cc

#-----------------------------------------------


lax:
	cd $(LAXDIR) && $(MAKE)

laxinterface:
	cd $(LAXDIR)/interfaces && $(MAKE)



#-----------------------------------------------

.PHONY: clean all install
clean:
	rm -f laxinput *.o

=== src/api/Makefile ===
#######################################################
##############                          ###############
#############  Laidout src/api Makefile  ##############
##############                          ###############
#######################################################

include ../../Makefile-toinclude
LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)
LD=g++
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm -lpng `imlib2-config --libs` -L$(LAXDIR) -L$(LAXIDIR)
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= -Wall $(DEBUGFLAGS) -I$(LAXDIR)/.. -I/usr/include/freetype2


objs= \
	reimpose.o \
	openandnew.o \
	importexport.o \
	functions.o 



api: $(objs)

depends:
	makedepend -fmakedepend -I.. -I$(LAXDIR)/.. -Y *.cc

include makedepend

hidegarbage:
	../hidegarbage *.cc

unhidegarbage:
	../hidegarbage -0 *.cc


.PHONY: clean printing hidegarbage unhidegarbage
clean:
	rm -f *.o

=== src/calculator/Makefile ===
###############################################################
##############                                  ###############
#############  Laidout src/calculator Makefile   ##############
##############                                  ###############
###############################################################

include ../../Makefile-toinclude
LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)
LD=g++
LDFLAGS= $(EXTRA_LDFLAGS) -L$(LAXDIR) -L$(LAXIDIR) -L/usr/local/lib -L/usr/X11R6/lib -rdynamic -lXi -lXext -lX11 -lm -lpng `imlib2-config --libs` `freetype-config --libs`\
		 `cups-config --libs` -ldl -lXft
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= -Wall $(HIDEGARBAGE) $(DEBUGFLAGS) $(EXTRA_CPPFLAGS)  -I$(LAXDIR)/.. `freetype-config --cflags` -I$(POLYPTYCHBASEDIR)


objs= \
	values.o \
	interpreter.o \
	calculator.o \
	curvevalue.o \
	shortcuttodef.o



dataobjects: $(objs)

depends:
	makedepend -fmakedepend -I.. -I$(LAXDIR)/.. -Y *.cc

include makedepend

objectatt2code: values.o objectatt2code.cc
	g++ $(CPPFLAGS) $@.cc values.o ../fieldplace.o -llaxkit -llaxinterfaces $(LDFLAGS) -lharfbuzz -lcairo -lfontconfig -lsqlite3 -o $@

hidegarbage:
	../hidegarbage *.cc

unhidegarbage:
	../hidegarbage -0 *.cc


.PHONY: clean printing hidegarbage unhidegarbage
clean:
	rm -f *.o objectatt2code

=== src/dataobjects/Makefile ===
###############################################################
##############                                  ###############
#############  Laidout src/dataobjects Makefile  ##############
##############                                  ###############
###############################################################

include ../../Makefile-toinclude
LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)
LD=g++
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm -lpng `imlib2-config --libs` -L$(LAXDIR) -L$(LAXIDIR)
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= -Wall $(DEBUGFLAGS) -I$(LAXDIR)/.. -I/usr/include/freetype2


objs= \
	group.o \
	objectcontainer.o \
	objectfilter.o \
	drawableobject.o \
	datafactory.o \
	groupinterface.o \
	epsdata.o \
	limagepatch.o \
	limagedata.o \
	limageinterface.o \
	lgradientdata.o \
	lpathsdata.o \
	mysterydata.o \
	lsomedataref.o \
	lengraverfilldata.o \
	lperspectiveinterface.o \
	lcaptiondata.o \
	ltextonpath.o \
	lvoronoidata.o \
	printermarks.o 



dataobjects: $(objs)

depends:
	makedepend -fmakedepend -I.. -I$(LAXDIR)/.. -Y *.cc

include makedepend

hidegarbage:
	../hidegarbage *.cc

unhidegarbage:
	../hidegarbage -0 *.cc


.PHONY: clean printing hidegarbage unhidegarbage
clean:
	rm -f *.o

=== src/extras/Makefile ===
##########################################################
##############                             ###############
#############  Laidout src/extras Makefile  ##############
##############                             ###############
##########################################################

include ../../Makefile-toinclude
LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)
LD=g++
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm -lpng `imlib2-config --libs` -L$(LAXDIR) -L$(LAXIDIR)
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= -Wall $(DEBUGFLAGS) -I$(LAXDIR)/.. -I/usr/include/freetype2


objs=  



extras: $(objs)

depends:
	makedepend -fmakedepend -I.. -I$(LAXDIR)/.. -Y *.cc

include makedepend

hidegarbage:
	../hidegarbage *.cc

unhidegarbage:
	../hidegarbage -0 *.cc


.PHONY: clean printing hidegarbage unhidegarbage
clean:
	rm -f *.o

=== src/filetypes/Makefile ===
#############################################################
##############                                ###############
#############  Laidout src/filetypes Makefile  ##############
##############                                ###############
#############################################################

include ../../Makefile-toinclude
LAXIDIR=$(LAXDIR)/interfaces
LAXOBJDIR=$(LAXDIR)
LD=g++
LDFLAGS= -L/usr/X11R6/lib -lX11 -lm -lpng `imlib2-config --libs` -L$(LAXDIR) -L$(LAXIDIR)
DEBUGFLAGS= -g -gdwarf-2
CPPFLAGS= $(HIDEGARBAGE) -Wall $(DEBUGFLAGS) -I$(LAXDIR)/.. -I/usr/include/freetype2


objs= \
	filefilters.o \
	filters.o \
	exportdialog.o \
	importdialog.o \
	image.o \
	image-gs.o \
	laidoutimport.o \
	pdf.o \
	podofoimposeplan.o \
	postscript.o \
	ppt.o \
	scribus.o \
	svg.o



filetypes: $(objs)

depends:
	makedepend -fmakedepend -I.. -I$(LAXDIR)/.. -Y *.cc

include makedepend

hidegarbage:
	../hidegarbage *.cc

unhidegarbage:
	../hidegarbage -0 *.cc


.PHONY: clean filetypes hidegarbage unhidegarbage
clean:
	rm -f *.o

=== src/icons/Makefile ===
# To regenerate the icons, remove icons.stamp from this 
# directory and type 'make'.

all:
	@if [ ! -e icons.stamp ] ; then \
			echo "Generating icons..."; \
			 ./makeimages.py; \
			 ./makeimages.py -icons-tiling.svg 100; \
			touch icons.stamp; \
		else echo "Icons already made! Remove icons.stamp and run make to redo."; fi
		

laidout-icons:
	if [ ! -d laidout-icons ] ; then mkdir laidout-icons; fi 
	cp -f *png *svg laidout-icons 
	zip -r laidout-icons.zip laidout-icons


.PHONY: laidout-icons

=== debian/changelog ===
laidout (0.096.1-0.1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Switch to source format 3.0 (quilt).
  * Add missing build-deps.
  * Fix up debian/copyright.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 04 May 2018 12:40:53 -0700

laidout (0.096.1) unstable; urgency=low

  * Dev version

 -- Tom Lechner <tomscoding@gmail.com>  Thu, 18 Dec 2015 21:15:50 -0800

=== debian/control ===
Source: laidout
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Tom Lechner <tomscoding@gmail.com>
Build-Depends: debhelper (>= 9.0.0),
               pkg-config,
               libpng12-dev | libpng-dev,
               libreadline-dev, libx11-dev,
               libxext-dev,
               libxi-dev,
               libxft-dev,
               libcups2-dev,
               libimlib2-dev,
               libfontconfig-dev,
               libfreetype6-dev,
               libssl-dev,
               xutils-dev,
               libcairo2-dev,
               libharfbuzz-dev,
               libsqlite3-dev,
               libgraphicsmagick++1-dev,
               mesa-common-dev,
               libglu1-mesa-dev,
               libftgl-dev,
               libgegl-dev (>= 0.3),
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://www.laidout.org

Package: laidout
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lay out pictures in cut and folded books.
 Laidout is desktop publishing software with interactive
 impostion editing, by folding paper on screen.
 Objects can be moved between pages by
 dragging on and off a scratchboard. Page order can be
 rearranged in a convenient page spread editor.
 .
 Development focus is on novel tool development, such
 as intuitive ways to arrange many objects, a tesselation
 tool, and a tool to produce fields of engraving lines.
 .
 A document can be edited as single pages, or how the
 pages appear when the book is assembled, or how the pages
 appear on master printing pages according to whichever
 imposition you use.
 .
 The definition of an imposition is broad enough to allow
 pages that do not even have to be rectangular. You can
 define and use a net that might correspond to some arcane
 polyhedron, for instance a dodecahedron with 12 images
 corresponding to the 12 months of the year.
